{{
Meta2 Compiler-Compiler for RamBlade

Copyright (c) 2010 Michael Green.  See end of file for terms of use.
}}


OBJ
   def     : "Definitions"             ' Definitions from DongleBasic
   mass    : "MassStorage"             ' EEPROM & SD card FAT file system support
   tv      : "OnePinTv"                ' 1-Pin TV Driver Interface
   kbd     : "OnePinKBD"               ' 1-Pin Keyboard Driver Interface

CON
   version   = 1                       ' Major version
   release   = 001                     ' Minor release
   testLevel = 5                       ' Test change level
   
   _clkmode  = def#clockMode
   _xinfreq  = def#xtalClock
   _free     = (def#endMemory - def#endFree + 3) / 4

PUB main | c, kbdPtr, tokPtr
  tv.str(string("RamBlade Template"))
  if version > 0 or release > 0 or testLevel > 0
    tv.str(string(" Version "))                           ' Identify program
    tv.dec(version)                                       '  and version
    tv.out(".")
    if release < 100
      tv.out("0")
    if release < 10
      tv.out("0")
    tv.dec(release)
    if testLevel > 0
      tv.out("a"+testLevel-1)
  waitcnt(clkfreq * 3 + cnt)
  mass.bootFile(string(":BOOT"))

PUB readSRAM(Addr)
  outa := Addr & $7FFFF
  dira |= $0007_FFFF          'address outputs                (+CE +WE =1 =deselect)
  dira |= $0010_0000          'address & CE outputs           (-CE     =0 =read)
  result := ina >> 24         'read from sram
  dira &= $FFCF_FFFF          'data & address outputs         (+CE +WE =1 =deselect)
  dira &= $00C8_0000          'allow for other I/O pins in use (19, 22, 23)

PUB writeSRAM(Addr,Data)
  outa := (Data << 24) | Addr 'data + address + -CE
  dira |= $FF07_FFFF          'data & address outputs         (+CE +WE =1 =deselect)
  dira |= $0030_0000          'data, address, CE & WE outputs (-CE -WE =0 =write)
  dira &= $FFCF_FFFF          'data & address outputs         (+CE +WE =1 =deselect)
  dira &= $00C8_0000          'allow for other I/O pins in use (19, 22, 23)

{{
                            TERMS OF USE: MIT License

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
}}
